<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS\Commands;
use CMSMS\CLI\App;
use CMSMS\CLI\GetOptExt\Command;
use CMSMS\CLI\GetOptExt\Option;
use CMSMS\CLI\GetOptExt\GetOpt;
use GetOpt\Operand;
use mams_user_query;
use mams_user_query_opt;

class GroupListPropsCommand extends Command
{
    public function __construct( App $app )
    {
        parent::__construct( $app, 'mams-group-list-props' );
        $this->addOperand( new Operand( 'group', Operand::REQUIRED ) );
        $this->addOption( Option::Create('r','raw')->setDescription('output raw data without cleaning'));
        $this->addOption( Option::Create('j','json')->setDescription('output data in JSON format'));
    }

    public function getShortDescription()
    {
        return 'List FEU group properties';
    }

    public function getLongDescription()
    {
        return 'This command will display a list of the property associations for a group';
    }

    public function handle()
    {
        $mams = \cms_utils::get_module(MOD_MAMS);
        $group = $this->getOperand('group')->value();
        $json = $this->getOption('json')->value();
        $raw = $this->getOption('raw')->value();

        $gid = $mams->GetGroupID($group);
        if( $gid < 1 ) throw new \RuntimeException("Group $group not found");

        $relns = $mams->GetGroupPropertyRelations($gid);
        if( empty($relns) ) return;

        $get_required = function(array $rec) {
            $arr = [ 0=>'off', 1=>'optional', 2=>'required', 3=>'hidden', 4=>'readonly' ];
            $v = (int) $rec['required'];
            if( isset($arr[$v]) ) return $arr[$v];
            return '*unknown*';
        };

        $get_lostun = function(array $rec) {
            $v = (int) $rec['lostunflag'];
            if( $v == 1 ) return 'yes';
            return 'no';
        };

        usort($relns,function($a,$b){
                if( $a['sort_key'] != $b['sort_key'] ) return $a['sort_key'] - $b['sort_key'];
                return strcmp($a['name'],$b['name']);
            });

        if( $json ) {
            array_walk($relns,function(&$item) use ($raw,$get_required,$get_lostun){
                    $item['group_id'] = (int) $item['group_id'];
                    $item['sort_key'] = (int) $item['sort_key'];
                    if( !$raw ) {
                        $item['required'] = $get_required($item);
                        $item['lostunflag'] = $get_lostun($item);
                    }
                });
            echo json_encode($relns, JSON_PRETTY_PRINT);
            return;
        }

        $fmt = "%-20s %-8s %-3s\n";
        printf($fmt,'name','required','lun');
        printf($fmt,'----','---','---');
        foreach( $relns as $rec ) {
            // output the property name, required, and lostunflag
            printf($fmt, $rec['name'], $get_required($rec), $get_lostun($rec));
        }
    }
} // end of class.
